# No Testcase run by default. To enable: rpm(or rpmbuild) -ba --define 'dotests 1' gzip*.spec
%{!?dotests: %define dotests 0}
Summary: The GNU data compression program.
Name: gzip
Version: 1.8
Release: 2 
Copyright: GPL
Group: Applications/File
Source: ftp://prep.ai.mit.edu/pub/gnu/gzip-%{version}.tar.gz
Prereq: /sbin/install-info
Buildroot: /var/tmp/gzip-root

%description
The gzip package contains the popular GNU gzip data compression
program.  Gzipped files have a .gz extension.

Gzip should be installed on your Red Hat Linux system, because it is a
very commonly used data compression program.

%prep
%setup -q

mkdir ../32bit
mv * ../32bit
mv ../32bit .
mkdir 64bit
cp -rp 32bit/* 64bit/

%build
# setup environment for 32-bit and 64-bit builds

export RM="/usr/bin/rm -f"
export AR="/usr/bin/ar -X32_64"
export NM="/usr/bin/nm -X32_64"

# First build the 64-bit version 
cd 64bit
export CC="gcc"
export CFLAGS="-maix64 -O3"
export LDFLAGS="-L/opt/freeware/lib64"
export OBJECT_MODE=64

./configure \
    --prefix=%{_prefix} \
    --mandir=%{_mandir} \
    --infodir=%{_infodir} \
    --enable-largefile

make %{?_smp_mflags}

if [ "%{dotests}" == 1 ]
then
    (gmake -i check || true)
fi

# Build 32bit version
cd ../32bit
export CFLAGS="-maix32 -D_LARGE_FILES -O3"
export LDFLAGS="-L/opt/freeware/lib"
export OBJECT_MODE=32
./configure \
    --prefix=%{_prefix} \
    --mandir=%{_mandir} \
    --infodir=%{_infodir} \
    --enable-largefile

make %{?_smp_mflags}

if [ "%{dotests}" == 1 ]
then
    (gmake -i check || true)
fi


%clean 
rm -rf $RPM_BUILD_ROOT

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
cd 64bit
export AR="/usr/bin/ar -X64"
export OBJECT_MODE=64
export CC=/opt/freeware/bin/gcc
export CFLAGS="-maix64 -O3"
gmake DESTDIR=${RPM_BUILD_ROOT} install

(
  cd ${RPM_BUILD_ROOT}%{_bindir}
  for f in *
  do
    mv ${f} ${f}_64
  done
)

cd ../32bit
export AR="/usr/bin/ar -X32"
export OBJECT_MODE=32
export CC=/opt/freeware/bin/gcc
export CFLAGS="-maix32 -D_LARGE_FILES -O3"
export LDFLAGS="-L/opt/freeware/lib"

make DESTDIR=${RPM_BUILD_ROOT} install

/usr/bin/strip -X32_64 ${RPM_BUILD_ROOT}%{_bindir}/* || :

(
  cd ${RPM_BUILD_ROOT}%{_bindir}
  for f in $(ls | grep -v -e _32 -e _64)
  do
    mv ${f} ${f}_32
    ln -sf ${f}_64 ${f}
  done
)

(   
    cd $RPM_BUILD_ROOT
    gzip -9fn .%{_infodir}/gzip.info*
    mkdir -p usr/linux/bin
    cd usr/linux/bin
    ln -sf ../../..%{_bindir}/* .
    cd -
    mkdir -p usr/bin
    cd usr/bin
    for f in locate updatedb 
    do
      ln -sf ../..%{_bindir}/$f .
    done
)


%post
/sbin/install-info %{_prefix}/info/gzip.info.gz %{_prefix}/info/dir

%preun
if [ $1 = 0 ]; then
    /sbin/install-info --delete %{_prefix}/info/gzip.info.gz %{_prefix}/info/dir
fi

%files
%doc 32bit/NEWS 32bit/README
/usr/bin/*
/usr/linux/bin/*
%{_prefix}/bin/*
%{_prefix}/man/*
%{_prefix}/info/gzip.info*

%changelog
* Thu Jul 12 2018 Ayappan P <ayappap2@in.ibm.com> 1.8-2
- Optimized build (gcc -O3)

* Thu Feb 08 2018 Ravi Hirekurabar<rhirekur@in.ibm.com> -1.8-1
- Updated to 1.8 built 64bit version.

* Fri Mar 01 2016 Nitish K Mishra <nitismis@in.ibm.com> 1.6-1
- Update to version 1.6

* Fri Jan 8 2015 Tony Reix <tony.reix@atos.net> 1.6
- Initial port on AIX 61

* Tue Jan 31 2012 Gerard Visiedo <gerard.visiedo@bull.net> 1.4-2
- Initial port on Aix61

* Tue Jun 1 2010 Jean Noel Cordenner <jean-noel.cordenner@bull.net> 1.4
- update to version 1.4
